/* Generated By:JJTree: Do not edit this line. ASTFloatingPointConstNode.java */

/* Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 */

package info.frantzen.testing.ssmsimulator.interpreter.javacc;

import info.frantzen.testing.ssmsimulator.types.ST_PseudoPosDouble;
import info.frantzen.testing.ssmsimulator.types.ST_PseudoPosDoubleInstance;

public class ASTFloatingPointConstNode extends SimpleNode {
    
    double val;
    
    public ASTFloatingPointConstNode(int id) {
        super(id);
    }
    
    public ASTFloatingPointConstNode(DumontParser p, int id) {
        super(p, id);
    }
    
    public void interpret() {
        stack[++top] = new Double(val);
    }
    
    public int typeCheck() throws DumontParser.IllegalTypeException {
        // the type is already set by the parser
        return type;
    }
    
    public String getPrologQuery() throws DumontParser.RuntimeViolation {
        
        // this is a copy from ST_PseudoPosDouble.checkRestriction, which is not static, so we cannot use it here:
        if (val < 0)
            throw new DumontParser.RuntimeViolation("Negative (pseudo) double constants are not supported by the solver: " + val);
        String s = Double.toString(val);
        if (s.substring(s.indexOf('.')+1).length() > ST_PseudoPosDouble.postPointLength)
            throw new DumontParser.RuntimeViolation("(Pseudo) double constant " + val + " does not match the post point length " + ST_PseudoPosDouble.postPointLength);
        
        
        ST_PseudoPosDoubleInstance i = new ST_PseudoPosDoubleInstance(val);
        
        return "node_s(" + i.asFlatInteger() + ",empty)";
    }
    
    
}
