/* Generated By:JJTree: Do not edit this line. Node.java */

/* Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 */

package info.frantzen.testing.ssmsimulator.interpreter.javacc;

/* All AST nodes must implement this interface.  It provides basic
   machinery for constructing the parent and child relationships
   between nodes. */

public interface Node {
    
    /** This method is called after the node has been made the current
     * node.  It indicates that child nodes can now be added to it. */
    public void jjtOpen();
    
    /** This method is called after all the child nodes have been
     * added. */
    public void jjtClose();
    
    /** This pair of methods are used to inform the node of its
     * parent. */
    public void jjtSetParent(Node n);
    public Node jjtGetParent();
    
    /** This method tells the node to add its argument to the node's
     * list of children.  */
    public void jjtAddChild(Node n, int i);
    
    /** This method returns a child node.  The children are numbered
     * from zero, left to right. */
    public Node jjtGetChild(int i);
    
    /** Return the number of children the node has. */
    public int jjtGetNumChildren();
    
    /************************* Added *******************/
    
    /** Interpret method */
    public void interpret() throws DumontParser.RuntimeViolation;
    
    /** Type check method, returns the type */
    public int typeCheck() throws DumontParser.IllegalTypeException;
    
    // To access the symtab
    public DumontParser getParser();
    
    // Generate the Prolog Query
    public String getPrologQuery() throws DumontParser.RuntimeViolation;
    
}
