/*
 * InstantiatedLocation.java
 * Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 *
 * Created on January 9, 2007, 5:05 PM
 *
 */

package info.frantzen.testing.ssmsimulator.ssm;

/**
 * An instantiated location is semantically a state (i.e. a location together with a
 * valuation of the location variables).
 * @author Lars Frantzen
 * @version 0.1
 */
public class InstantiatedLocation {
    
    private Location loc;
    private Valuation valuation;
    
    /**
     * Creates a new instance of InstantiatedLocation.
     * @param loc an SSM location
     * @param valuation a valuation for the location vaiables
     */
    public InstantiatedLocation(Location loc, Valuation valuation) {
        this.loc = loc;
        this.valuation = valuation;
    }
    
    /**
     * Getter for the location attribute.
     * @return the location
     */
    public Location getLocation() {
        return loc;
    }
    
    /**
     * Getter for the valuation attribute.
     * @return the valuation
     */
    public Valuation getValuation() {
        return valuation;
    }
    
}
