/*
 * ST_BooleanInstance.java
 * Copyright (C) 2007 Lars Frantzen
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * See the LICENSE file for the full license
 *
 * Created on 30. Dezember 2006, 14:41
 *
 */

package info.frantzen.testing.ssmsimulator.types;

/**
 * An ST_BooleanInstance is an instance of an {@link ST_Boolean}.
 * @author Lars Frantzen
 * @version 0.1
 */
public class ST_BooleanInstance extends SimpleTypeInstance {
    
    /**
     * Creates a new instance of ST_BooleanInstance.
     * @param value a Boolean represented by the ST_BooleanInstance
     */
    public ST_BooleanInstance(Boolean value) {
        super(value);
    }
    
    
    /**
     * A string representation of the ST_BooleanInstance.
     * @return a string representation of the ST_BooleanInstance
     */
    public String toString() {
        return ((Boolean) getValue()).toString();
    }

    /**
     * Clones this ST_BooleanInstance.
     * @return the cloned ST_BooleanInstance
     */
    public ST_BooleanInstance clone() {
        return new ST_BooleanInstance(new Boolean((Boolean) getValue()));
    }
    
}
